local eventFrame = CreateFrame("Frame");
local QuickHealth = LibStub("LibQuickHealth-1.0");
local RL = AceLibrary("Roster-2.1");
local _G = getfenv(0);

-- env changement code taken from interruptus
local proxyEnv =
{
	UnitHealth = function(...) return QuickHealth.UnitHealth(QuickHealth, ...); end,
}

setmetatable(proxyEnv, { 
	__index    = _G,
	__newindex = function (t, k, v) _G[k] = v end,
})

local oldEnv;
eventFrame:SetScript("OnEvent", function(self)
	oldEnv = getfenv(GridStatusHealth.UpdateUnit);
	-- Make sure that GridStatusHeals uses the HP from QuickHealth too
	setfenv(GridStatusHeals.UpdateIncomingHeals, proxyEnv);
	-- Update health bars when HealthUpdated triggers
	QuickHealth.RegisterCallback(self, "HealthUpdated", function(event, GUID, newHealth)
		setfenv(GridStatusHealth.UpdateUnit, proxyEnv);
		for u in RL:IterateRoster(true) do
			local unitid = u.unitid;
			if(GUID == UnitGUID(unitid)) then
				GridStatusHealth:UpdateUnit(unitid);
			end
		end
		setfenv(GridStatusHealth.UpdateUnit, oldEnv);
	end);
end);

eventFrame:RegisterEvent("PLAYER_LOGIN");